kind: pipeline
type: docker
name: PipelineQwirkle
trigger:
  event:
    - push

steps:
  - name: build
    image: mcr.microsoft.com/dotnet/sdk:8.0
    commands:
      - cd ./Qwirkle
      - dotnet restore QwirkleWithoutMaui.sln
      - dotnet build QwirkleWithoutMaui.sln -c Release --no-restore
      - dotnet publish QwirkleWithoutMaui.sln -c Release --no-restore -o $CI_PROJECT_DIR/build/release

  - name: tests
    image: mcr.microsoft.com/dotnet/sdk:8.0
    commands:
      - cd ./Qwirkle
      - dotnet restore QwirkleWithoutMaui.sln
      - dotnet test QwirkleWithoutMaui.sln --no-restore

  - name: generate-and-deploy-docs
    image: hub.codefirst.iut.uca.fr/thomas.bellembois/codefirst-docdeployer
    failure: ignore
    volumes:
      - name: docs
        path: /docs
    commands:
      - /entrypoint.sh

  - name: code-inspection
    image: hub.codefirst.iut.uca.fr/marc.chevaldonne/codefirst-dronesonarplugin-dotnet8
    secrets: [ SECRET_SONAR_LOGIN ]
    settings:
      sonar_host: https://codefirst.iut.uca.fr/sonar/
      sonar_token:
        from_secret: SECRET_SONAR_LOGIN
    commands:
      - cd ./Qwirkle
      - dotnet restore QwirkleWithoutMaui.sln
      - dotnet sonarscanner begin /k:QwirkleSonar /d:sonar.host.url=$${PLUGIN_SONAR_HOST} /d:sonar.coverageReportPaths="coveragereport/SonarQube.xml" /d:sonar.coverage.exclusions="Tests/**" /d:sonar.login=$${PLUGIN_SONAR_TOKEN} 
      - dotnet build QwirkleWithoutMaui.sln -c Release --no-restore
      - dotnet test QwirkleWithoutMaui.sln --logger trx --no-restore /p:CollectCoverage=true /p:CoverletOutputFormat=cobertura --collect "XPlat Code Coverage"
      - reportgenerator -reports:"**/coverage.cobertura.xml" -reporttypes:SonarQube -targetdir:"coveragereport"
      - dotnet publish QwirkleWithoutMaui.sln -c Release --no-restore -o CI_PROJECT_DIR/build/release
      - dotnet sonarscanner end /d:sonar.login=$${PLUGIN_SONAR_TOKEN}